/*********************************************************************************/
/********** THIS FILE IS GENERATED BY TOUCHGFX DESIGNER, DO NOT MODIFY ***********/
/*********************************************************************************/
#ifndef CUSTOMCONTROLS_VIEW_BASE_HPP
#define CUSTOMCONTROLS_VIEW_BASE_HPP

#include <gui/common/FrontendApplication.hpp>
#include <mvp/View.hpp>
#include <gui/customcontrols_screen/CustomControlsPresenter.hpp>
#include <touchgfx/widgets/Image.hpp>
#include <gui/containers/mcuLoadWidget.hpp>
#include <touchgfx/widgets/Button.hpp>

class CustomControlsViewBase : public touchgfx::View<CustomControlsPresenter>
{
public:
    CustomControlsViewBase();
    virtual ~CustomControlsViewBase() {}

    virtual void setupScreen();

    /*
     * Custom Action Handlers
     */
    virtual void menuUpClickedHandler()
    {
        // Override and implement this function in CustomControlsView
    }

    virtual void menuDownClickedHandler()
    {
        // Override and implement this function in CustomControlsView
    }

protected:
    FrontendApplication& application() {
        return *static_cast<FrontendApplication*>(Application::getInstance());
    }

    /*
     * Member Declarations
     */
    touchgfx::Image menuBackground;
    touchgfx::Image background;
    McuLoadWidget mcuLoad;
    touchgfx::Button menuUp;
    touchgfx::Button menuDown;
    touchgfx::Button gotoMenu;

private:

    /*
     * Callback Handler Declarations
     */
    void buttonCallbackHandler(const touchgfx::AbstractButton& src);

    /*
     * Callback Declarations
     */
    touchgfx::Callback<CustomControlsViewBase, const touchgfx::AbstractButton&> buttonCallback;

};

#endif // CUSTOMCONTROLS_VIEW_BASE_HPP
